Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.10.0/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.10.0/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.10.0/xf86Modes.h	(revision 96236)
@@ -47,5 +47,5 @@
 extern _X_EXPORT int
 xf86ModeWidth (const DisplayModeRec *mode, Rotation rotation);
-    
+
 extern _X_EXPORT int
 xf86ModeHeight (const DisplayModeRec *mode, Rotation rotation);
Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.3.0.0/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.3.0.0/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.3.0.0/xf86Modes.h	(revision 96236)
@@ -46,5 +46,5 @@
 int
 xf86ModeWidth (DisplayModePtr mode, Rotation rotation);
-    
+
 int
 xf86ModeHeight (DisplayModePtr mode, Rotation rotation);
Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.4.2/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.4.2/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.4.2/xf86Modes.h	(revision 96236)
@@ -46,5 +46,5 @@
 int
 xf86ModeWidth (DisplayModePtr mode, Rotation rotation);
-    
+
 int
 xf86ModeHeight (DisplayModePtr mode, Rotation rotation);
Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.5.3/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.5.3/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.5.3/xf86Modes.h	(revision 96236)
@@ -47,5 +47,5 @@
 int
 xf86ModeWidth (DisplayModePtr mode, Rotation rotation);
-    
+
 int
 xf86ModeHeight (DisplayModePtr mode, Rotation rotation);
Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.6.5/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.6.5/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.6.5/xf86Modes.h	(revision 96236)
@@ -47,5 +47,5 @@
 int
 xf86ModeWidth (const DisplayModeRec *mode, Rotation rotation);
-    
+
 int
 xf86ModeHeight (const DisplayModeRec *mode, Rotation rotation);
Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.7.7/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.7.7/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.7.7/xf86Modes.h	(revision 96236)
@@ -47,5 +47,5 @@
 extern _X_EXPORT int
 xf86ModeWidth (const DisplayModeRec *mode, Rotation rotation);
-    
+
 extern _X_EXPORT int
 xf86ModeHeight (const DisplayModeRec *mode, Rotation rotation);
Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.8.0/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.8.0/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.8.0/xf86Modes.h	(revision 96236)
@@ -47,5 +47,5 @@
 extern _X_EXPORT int
 xf86ModeWidth (const DisplayModeRec *mode, Rotation rotation);
-    
+
 extern _X_EXPORT int
 xf86ModeHeight (const DisplayModeRec *mode, Rotation rotation);
Index: trunk/src/VBox/Additions/x11/x11include/xorg-server-1.9.0/xf86Modes.h
===================================================================
--- trunk/src/VBox/Additions/x11/x11include/xorg-server-1.9.0/xf86Modes.h	(revision 95911)
+++ trunk/src/VBox/Additions/x11/x11include/xorg-server-1.9.0/xf86Modes.h	(revision 96236)
@@ -47,5 +47,5 @@
 extern _X_EXPORT int
 xf86ModeWidth (const DisplayModeRec *mode, Rotation rotation);
-    
+
 extern _X_EXPORT int
 xf86ModeHeight (const DisplayModeRec *mode, Rotation rotation);